/**
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.rax1;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tdt4250.ra.rax1.Rax1Factory
 * @model kind="package"
 * @generated
 */
public interface Rax1Package extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "rax1";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "platform:/plugin/tdt4250.ra.xtext1";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "rax1";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  Rax1Package eINSTANCE = tdt4250.ra.rax1.impl.Rax1PackageImpl.init();

  /**
   * The meta object id for the '{@link tdt4250.ra.rax1.impl.DepartmentImpl <em>Department</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tdt4250.ra.rax1.impl.DepartmentImpl
   * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getDepartment()
   * @generated
   */
  int DEPARTMENT = 0;

  /**
   * The feature id for the '<em><b>Short Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPARTMENT__SHORT_NAME = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPARTMENT__NAME = 1;

  /**
   * The feature id for the '<em><b>Persons</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPARTMENT__PERSONS = 2;

  /**
   * The feature id for the '<em><b>Courses</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPARTMENT__COURSES = 3;

  /**
   * The number of structural features of the '<em>Department</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPARTMENT_FEATURE_COUNT = 4;

  /**
   * The meta object id for the '{@link tdt4250.ra.rax1.impl.PersonImpl <em>Person</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tdt4250.ra.rax1.impl.PersonImpl
   * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getPerson()
   * @generated
   */
  int PERSON = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PERSON__NAME = 0;

  /**
   * The number of structural features of the '<em>Person</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PERSON_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link tdt4250.ra.rax1.impl.CourseImpl <em>Course</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tdt4250.ra.rax1.impl.CourseImpl
   * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getCourse()
   * @generated
   */
  int COURSE = 2;

  /**
   * The feature id for the '<em><b>Code</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COURSE__CODE = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COURSE__NAME = 1;

  /**
   * The feature id for the '<em><b>Allocations</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COURSE__ALLOCATIONS = 2;

  /**
   * The number of structural features of the '<em>Course</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int COURSE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link tdt4250.ra.rax1.impl.ResourceAllocationImpl <em>Resource Allocation</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see tdt4250.ra.rax1.impl.ResourceAllocationImpl
   * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getResourceAllocation()
   * @generated
   */
  int RESOURCE_ALLOCATION = 3;

  /**
   * The feature id for the '<em><b>Person</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_ALLOCATION__PERSON = 0;

  /**
   * The feature id for the '<em><b>Percentage</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_ALLOCATION__PERCENTAGE = 1;

  /**
   * The number of structural features of the '<em>Resource Allocation</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_ALLOCATION_FEATURE_COUNT = 2;


  /**
   * Returns the meta object for class '{@link tdt4250.ra.rax1.Department <em>Department</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Department</em>'.
   * @see tdt4250.ra.rax1.Department
   * @generated
   */
  EClass getDepartment();

  /**
   * Returns the meta object for the attribute '{@link tdt4250.ra.rax1.Department#getShortName <em>Short Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Short Name</em>'.
   * @see tdt4250.ra.rax1.Department#getShortName()
   * @see #getDepartment()
   * @generated
   */
  EAttribute getDepartment_ShortName();

  /**
   * Returns the meta object for the attribute '{@link tdt4250.ra.rax1.Department#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see tdt4250.ra.rax1.Department#getName()
   * @see #getDepartment()
   * @generated
   */
  EAttribute getDepartment_Name();

  /**
   * Returns the meta object for the containment reference list '{@link tdt4250.ra.rax1.Department#getPersons <em>Persons</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Persons</em>'.
   * @see tdt4250.ra.rax1.Department#getPersons()
   * @see #getDepartment()
   * @generated
   */
  EReference getDepartment_Persons();

  /**
   * Returns the meta object for the containment reference list '{@link tdt4250.ra.rax1.Department#getCourses <em>Courses</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Courses</em>'.
   * @see tdt4250.ra.rax1.Department#getCourses()
   * @see #getDepartment()
   * @generated
   */
  EReference getDepartment_Courses();

  /**
   * Returns the meta object for class '{@link tdt4250.ra.rax1.Person <em>Person</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Person</em>'.
   * @see tdt4250.ra.rax1.Person
   * @generated
   */
  EClass getPerson();

  /**
   * Returns the meta object for the attribute '{@link tdt4250.ra.rax1.Person#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see tdt4250.ra.rax1.Person#getName()
   * @see #getPerson()
   * @generated
   */
  EAttribute getPerson_Name();

  /**
   * Returns the meta object for class '{@link tdt4250.ra.rax1.Course <em>Course</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Course</em>'.
   * @see tdt4250.ra.rax1.Course
   * @generated
   */
  EClass getCourse();

  /**
   * Returns the meta object for the attribute '{@link tdt4250.ra.rax1.Course#getCode <em>Code</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Code</em>'.
   * @see tdt4250.ra.rax1.Course#getCode()
   * @see #getCourse()
   * @generated
   */
  EAttribute getCourse_Code();

  /**
   * Returns the meta object for the attribute '{@link tdt4250.ra.rax1.Course#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see tdt4250.ra.rax1.Course#getName()
   * @see #getCourse()
   * @generated
   */
  EAttribute getCourse_Name();

  /**
   * Returns the meta object for the containment reference list '{@link tdt4250.ra.rax1.Course#getAllocations <em>Allocations</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Allocations</em>'.
   * @see tdt4250.ra.rax1.Course#getAllocations()
   * @see #getCourse()
   * @generated
   */
  EReference getCourse_Allocations();

  /**
   * Returns the meta object for class '{@link tdt4250.ra.rax1.ResourceAllocation <em>Resource Allocation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Resource Allocation</em>'.
   * @see tdt4250.ra.rax1.ResourceAllocation
   * @generated
   */
  EClass getResourceAllocation();

  /**
   * Returns the meta object for the reference '{@link tdt4250.ra.rax1.ResourceAllocation#getPerson <em>Person</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Person</em>'.
   * @see tdt4250.ra.rax1.ResourceAllocation#getPerson()
   * @see #getResourceAllocation()
   * @generated
   */
  EReference getResourceAllocation_Person();

  /**
   * Returns the meta object for the attribute '{@link tdt4250.ra.rax1.ResourceAllocation#getPercentage <em>Percentage</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Percentage</em>'.
   * @see tdt4250.ra.rax1.ResourceAllocation#getPercentage()
   * @see #getResourceAllocation()
   * @generated
   */
  EAttribute getResourceAllocation_Percentage();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  Rax1Factory getRax1Factory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link tdt4250.ra.rax1.impl.DepartmentImpl <em>Department</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tdt4250.ra.rax1.impl.DepartmentImpl
     * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getDepartment()
     * @generated
     */
    EClass DEPARTMENT = eINSTANCE.getDepartment();

    /**
     * The meta object literal for the '<em><b>Short Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DEPARTMENT__SHORT_NAME = eINSTANCE.getDepartment_ShortName();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DEPARTMENT__NAME = eINSTANCE.getDepartment_Name();

    /**
     * The meta object literal for the '<em><b>Persons</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPARTMENT__PERSONS = eINSTANCE.getDepartment_Persons();

    /**
     * The meta object literal for the '<em><b>Courses</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPARTMENT__COURSES = eINSTANCE.getDepartment_Courses();

    /**
     * The meta object literal for the '{@link tdt4250.ra.rax1.impl.PersonImpl <em>Person</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tdt4250.ra.rax1.impl.PersonImpl
     * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getPerson()
     * @generated
     */
    EClass PERSON = eINSTANCE.getPerson();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PERSON__NAME = eINSTANCE.getPerson_Name();

    /**
     * The meta object literal for the '{@link tdt4250.ra.rax1.impl.CourseImpl <em>Course</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tdt4250.ra.rax1.impl.CourseImpl
     * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getCourse()
     * @generated
     */
    EClass COURSE = eINSTANCE.getCourse();

    /**
     * The meta object literal for the '<em><b>Code</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COURSE__CODE = eINSTANCE.getCourse_Code();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute COURSE__NAME = eINSTANCE.getCourse_Name();

    /**
     * The meta object literal for the '<em><b>Allocations</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference COURSE__ALLOCATIONS = eINSTANCE.getCourse_Allocations();

    /**
     * The meta object literal for the '{@link tdt4250.ra.rax1.impl.ResourceAllocationImpl <em>Resource Allocation</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see tdt4250.ra.rax1.impl.ResourceAllocationImpl
     * @see tdt4250.ra.rax1.impl.Rax1PackageImpl#getResourceAllocation()
     * @generated
     */
    EClass RESOURCE_ALLOCATION = eINSTANCE.getResourceAllocation();

    /**
     * The meta object literal for the '<em><b>Person</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RESOURCE_ALLOCATION__PERSON = eINSTANCE.getResourceAllocation_Person();

    /**
     * The meta object literal for the '<em><b>Percentage</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RESOURCE_ALLOCATION__PERCENTAGE = eINSTANCE.getResourceAllocation_Percentage();

  }

} //Rax1Package
